<template>
  <div class="console-window">
    <el-button type="primary" @click="loadConsole">Create console</el-button>
    <el-button type="warning" @click="testWrite">Test write</el-button>
    <div class="console" id="terminal">
      
    </div>
  </div>
</template>

<script>
import { remote } from 'electron'

import { Terminal } from 'xterm';
import { FitAddon } from 'xterm-addon-fit';
import { WebLinksAddon } from 'xterm-addon-web-links';

let terminal = null;

export default {
  components: {
    
  },
  methods: {
    loadConsole() {
      terminal = new Terminal();
      const fitAddon = new FitAddon();
      const webLinksAddon = new WebLinksAddon();

      terminal.loadAddon(fitAddon);
      terminal.loadAddon(webLinksAddon);

      terminal.open(document.getElementById('terminal'));
      terminal.write('Hello from \x1B[1;3;31mxterm.js\x1B[0m $ Test https://www.google.com/ wow')
      terminal.onData(data => terminal.write(data))
      fitAddon.fit();
    },
    testWrite() {
      terminal.write('\r\nUhoh')
    },
    openURL (url) {
      remote.shell.openExternal(url)
    }
  }
}
</script>

<style lang="scss">
  .console-window, .console {
    height: calc(100% - 20px - 14px);
  }
</style>
